Index: c/src/exec/score/cpu/hppa1.1/cpu_asm.s
===================================================================
--- c/src/exec/score/cpu/hppa1.1/cpu_asm.s	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/hppa1.1/cpu_asm.s	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -50,4 +50,5 @@
 isr_arg0           .reg    %cr24
 isr_r9             .reg    %cr25
+isr_r8             .reg    %cr26
 
 #
@@ -106,28 +107,23 @@
 #  The following macro and the 32 instantiations of the macro
 #  are necessary to determine which interrupt vector occurred.
-#  The following macro allows a unique entry point to be defined
-#  for each vector.
-#
-# r9 was loaded with the vector before branching here
-#   scratch registers available:   gr1, gr8, gr9, gr16, gr17, gr24
-#
-# NOTE:
-#  .align 32   doesn not seem to work in the continuation below
-#  so just have to count 8 instructions
-#
-# NOTE:
-#    this whole scheme needs to be rethought for TLB traps which
-#    have requirements about what tlb faults they can incur.
-#    ref:  TLB Operation Requirements in 1.1 arch book
+#
+#  r9 is loaded with the vector number and then we jump to
+#    the first level interrupt handler.  In most cases this
+#    is _Generic_ISR_Handler.  In a few cases (such as TLB misc)
+#    it may be to some other entry point.
+#
+
+# table for first level interrupt handlers
+        .import   HPPA_first_level_interrupt_handler, data
 
 #define THANDLER(vector) \
-        mtctl   %r9,  isr_r9 !         \
-        b       _Generic_ISR_Handler!        \
-        ldi     vector, %r9!       \
-        nop ! \
-        nop ! \
-        nop ! \
-        nop ! \
-        nop
+        mtctl   %r9,  isr_r9 ! \
+        mtctl   %r8,  isr_r8 ! \
+        ldi     vector, %r9  ! \
+        ldil    L%HPPA_first_level_interrupt_handler,%r8 ! \
+        ldo     R%HPPA_first_level_interrupt_handler(%r8),%r8 ! \
+        ldwx,s  %r9(%r8),%r8 ! \
+        bv      0(%r8) ! \
+        mfctl   isr_r8, %r8
 
         .align 4096
@@ -211,8 +207,4 @@
 	.ENTRY
 
-# Turn on the D bit in psw so we can start saving stuff on stack
-# (interrupt context pieces that need to be saved before the RFI)
-
-        ssm       HPPA_PSW_D, %r0
         mtctl     arg0, isr_arg0
 
@@ -236,29 +228,4 @@
         mfctl     %sar, arg0
         stw       arg0, SAR_OFFSET(sp)
-
-# Prepare to re-enter virtual mode
-# We need Q in case the interrupt handler enables interrupts
-#
-
-        ldil      L%CPU_PSW_DEFAULT, arg0
-        ldo       R%CPU_PSW_DEFAULT(arg0), arg0
-        mtctl     arg0, ipsw
-
-# Now jump to "rest_of_isr_handler" with the rfi
-# We are assuming the space queues are all correct already
-
-	ldil 	  L%rest_of_isr_handler, arg0
-	ldo	  R%rest_of_isr_handler(arg0), arg0
-	mtctl	  arg0, pcoq
-	ldo	  4(arg0), arg0
-	mtctl	  arg0, pcoq
-
-        rfi
-	nop
-
-# At this point we are back in virtual mode and all our
-#  normal addressing is once again ok.
-
-rest_of_isr_handler:
 
 #
@@ -282,5 +249,5 @@
         stw         %r7,R7_OFFSET(sp)
         stw         %r8,R8_OFFSET(sp)
-        stw         %r9,R9_OFFSET(sp)
+# skip r9
         stw         %r10,R10_OFFSET(sp)
         stw         %r11,R11_OFFSET(sp)
@@ -299,5 +266,5 @@
         stw         %r24,R24_OFFSET(sp)
         stw         %r25,R25_OFFSET(sp)
-        stw         %r26,R26_OFFSET(sp)
+# skip arg0
         stw         %r27,R27_OFFSET(sp)
         stw         %r28,R28_OFFSET(sp)
@@ -325,5 +292,31 @@
 # At this point we are done with isr_arg0, and isr_r9 control registers
 #
-
+# Prepare to re-enter virtual mode
+# We need Q in case the interrupt handler enables interrupts
+#
+
+        ldil      L%CPU_PSW_DEFAULT, arg0
+        ldo       R%CPU_PSW_DEFAULT(arg0), arg0
+        mtctl     arg0, ipsw
+
+# Now jump to "rest_of_isr_handler" with the rfi
+# We are assuming the space queues are all correct already
+
+	ldil 	  L%rest_of_isr_handler, arg0
+	ldo	  R%rest_of_isr_handler(arg0), arg0
+	mtctl	  arg0, pcoq
+	ldo	  4(arg0), arg0
+	mtctl	  arg0, pcoq
+
+        rfi
+	nop
+
+# At this point we are back in virtual mode and all our
+#  normal addressing is once again ok.
+#
+#  It is now ok to take an exception or trap
+#
+
+rest_of_isr_handler:
 
 # Point to beginning of float context and
@@ -409,5 +402,5 @@
 # (_ISR_Nest_level == 0)
 
-        rsm        HPPA_PSW_I, %r0
+        rsm        HPPA_PSW_I + HPPA_PSW_R, %r0
         ldw        -4(sp), sp
 
@@ -449,4 +442,5 @@
 	comibt,=,n 0,%r8,isr_restore
 
+
 # OK, something happened while in ISR and we need to switch to a task
 # other than the one which was interrupted or the
@@ -466,7 +460,8 @@
         ldo        -128(sp),sp
 
-        rsm        HPPA_PSW_I, %r0
-
 isr_restore:
+
+# enable interrupts during most of restore
+        ssm        HPPA_PSW_I, %r0
 
 # Get a pointer to beginning of our stack frame
@@ -489,19 +484,4 @@
 	.EXPORT _CPU_Context_restore
 _CPU_Context_restore:
-
-# Turn off Q & I so we can write pcoq
-        rsm        HPPA_PSW_Q + HPPA_PSW_I, %r0
-
-        ldw        IPSW_OFFSET(arg0), %r8
-        mtctl      %r8, ipsw
-
-        ldw        SAR_OFFSET(arg0), %r9
-        mtctl      %r9, sar
-
-        ldw        PCOQFRONT_OFFSET(arg0), %r10
-        mtctl      %r10, pcoq
-
-        ldw        PCOQBACK_OFFSET(arg0), %r11
-        mtctl      %r11, pcoq
 
 #
@@ -532,6 +512,6 @@
         ldw         R23_OFFSET(arg0),%r23
         ldw         R24_OFFSET(arg0),%r24
-        ldw         R25_OFFSET(arg0),%r25
-# skipping r26 (aka arg0) until we are done with it
+# skipping r25; used as scratch register below
+# skipping r26 (arg0) until we are done with it
         ldw         R27_OFFSET(arg0),%r27
         ldw         R28_OFFSET(arg0),%r28
@@ -540,5 +520,22 @@
         ldw         R31_OFFSET(arg0),%r31
 
-# Must load r26 last since it is arg0
+# Turn off Q & R & I so we can write interrupt control registers
+        rsm        HPPA_PSW_Q + HPPA_PSW_R + HPPA_PSW_I, %r0
+
+        ldw        IPSW_OFFSET(arg0), %r25
+        mtctl      %r25, ipsw
+
+        ldw        SAR_OFFSET(arg0), %r25
+        mtctl      %r25, sar
+
+        ldw        PCOQFRONT_OFFSET(arg0), %r25
+        mtctl      %r25, pcoq
+
+        ldw        PCOQBACK_OFFSET(arg0), %r25
+        mtctl      %r25, pcoq
+
+# Load r25 with interrupts off
+        ldw         R25_OFFSET(arg0),%r25
+# Must load r26 (arg0) last
         ldw         R26_OFFSET(arg0),%r26
 
Index: c/src/exec/score/cpu/hppa1.1/hppa.h
===================================================================
--- c/src/exec/score/cpu/hppa1.1/hppa.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/hppa1.1/hppa.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,5 @@
 /*
- *	@(#)hppa.h	1.13 - 95/09/21
- *	
+ * @(#)hppa.h	1.17 - 95/12/13
+ * 
  *
  *  Description:
@@ -210,4 +210,5 @@
 #define HPPA_INTERRUPT_EXTERNAL_INTERVAL_TIMER         HPPA_INTERRUPT_EXTERNAL_0
 #define HPPA_EXTERNAL_INTERRUPTS                       32
+#define HPPA_INTERNAL_INTERRUPTS                       32
 
 /* BSP defined interrupts begin here */
@@ -647,5 +648,9 @@
 
 
-#ifndef ASM
+/*
+ * this won't work in ASM or non-GNU compilers
+ */
+
+#if !defined(ASM) && defined(__GNUC__)
 
 /*
@@ -700,19 +705,13 @@
 EMIT_CONTROLS(tr7, HPPA_CR31);               /* CR31 */
 
+#endif /* ASM and GNU */
+
 /*
  * If and How to invoke the debugger (a ROM debugger generally)
  */
-
-#ifdef SIMHPPA_ROM
-/* invoke the pflow debugger */
-#define CPU_INVOKE_DEBUGGER  \
+#define CPU_INVOKE_DEBUGGER \
     do { \
-        extern void debugger_break(void); \
-        debugger_break(); \
+        HPPA_ASM_BREAK(1,1); \
     } while (0)
-#endif
-
-
-#endif /* ASM */
 
 #ifdef __cplusplus
Index: c/src/exec/score/cpu/unix/cpu.c
===================================================================
--- c/src/exec/score/cpu/unix/cpu.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/unix/cpu.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -88,5 +88,5 @@
 
   sigemptyset(&posix_empty_mask);
- 
+
   /*
    * Block all the signals except SIGTRAP for the debugger
@@ -603,5 +603,4 @@
   extern boolean     _Context_Switch_necessary;
 
-
   if (_ISR_Nest_level++ == 0) {
       /* switch to interrupt stack */
@@ -636,17 +635,32 @@
 void _CPU_Stray_signal(int sig_num)
 {
-  char buffer[ 4 ];   
-
-  /* 
-   *  We avoid using the stdio section of the library.
-   *  The following is generally safe.
-   */
-
-  buffer[ 0 ] = (sig_num >> 4) + 0x30;
-  buffer[ 1 ] = (sig_num & 0xf) + 0x30;
-  buffer[ 2 ] = '\n';
-
-  write( 2, "Stray signal 0x", 12 );
-  write( 2, buffer, 3 );
+  char buffer[ 4 ];
+ 
+  /*
+   * print "stray" msg about ones which that might mean something
+   * Avoid using the stdio section of the library.
+   * The following is generally safe.
+   */
+ 
+  switch (sig_num)
+  {
+      case SIGCLD:
+          break;
+ 
+      default:
+      {
+          /*
+           *  We avoid using the stdio section of the library.
+           *  The following is generally safe.
+           */
+ 
+          buffer[ 0 ] = (sig_num >> 4) + 0x30;
+          buffer[ 1 ] = (sig_num & 0xf) + 0x30;
+          buffer[ 2 ] = '\n';
+ 
+          write( 2, "Stray signal 0x", 12 );
+          write( 2, buffer, 3 );
+      }
+  }
  
   /*
Index: c/src/exec/score/cpu/unix/cpu.h
===================================================================
--- c/src/exec/score/cpu/unix/cpu.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/unix/cpu.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -279,5 +279,9 @@
  */
 
+#ifdef __GNUC__
 #define CPU_STRUCTURE_ALIGNMENT          __attribute__ ((aligned (32)))
+#else
+#define CPU_STRUCTURE_ALIGNMENT
+#endif
 
 /*
Index: c/src/exec/score/cpu/unix/unixtypes.h
===================================================================
--- c/src/exec/score/cpu/unix/unixtypes.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/unix/unixtypes.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -25,4 +25,12 @@
 
 /*
+ * some C++ compilers (eg: HP's) don't do 'signed' or 'volatile'
+ */
+#if defined(__cplusplus) && !defined(__GNUC__)
+#define signed
+#define volatile
+#endif
+
+/*
  *  This section defines the basic types for this processor.
  */
@@ -31,5 +39,4 @@
 typedef unsigned short unsigned16;     /* unsigned 16-bit integer */
 typedef unsigned int   unsigned32;     /* unsigned 32-bit integer */
-typedef unsigned long long unsigned64; /* unsigned 64-bit integer */
 
 typedef unsigned16     Priority_Bit_map_control;
@@ -38,5 +45,12 @@
 typedef signed short     signed16;     /* 16-bit signed integer */
 typedef signed int       signed32;     /* 32-bit signed integer */
+
+/*
+ * some C++ compilers (eg: HP's) don't do 'long long'
+ */
+#if defined(__GNUC__)
+typedef unsigned long long unsigned64; /* unsigned 64-bit integer */
 typedef signed long long signed64;     /* 64 bit signed integer */
+#endif
 
 typedef unsigned32 boolean;     /* Boolean value   */
Index: c/src/exec/score/headers/system.h
===================================================================
--- c/src/exec/score/headers/system.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/headers/system.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -57,12 +57,13 @@
 
 #ifdef USE_INLINES
-#define STATIC static
-#define INLINE __inline__
+# define STATIC static
+# ifdef __GNUC__
+#  define INLINE __inline__
+# else
+#  define INLINE inline
+# endif
 #else
-/*
-#error Only the GNU C compiler is currently supported!!!
-*/
-#define STATIC
-#define INLINE
+# define STATIC
+# define INLINE
 #endif
 
Index: c/src/exec/score/include/rtems/system.h
===================================================================
--- c/src/exec/score/include/rtems/system.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/include/rtems/system.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -57,12 +57,13 @@
 
 #ifdef USE_INLINES
-#define STATIC static
-#define INLINE __inline__
+# define STATIC static
+# ifdef __GNUC__
+#  define INLINE __inline__
+# else
+#  define INLINE inline
+# endif
 #else
-/*
-#error Only the GNU C compiler is currently supported!!!
-*/
-#define STATIC
-#define INLINE
+# define STATIC
+# define INLINE
 #endif
 
Index: c/src/exec/score/inline/address.inl
===================================================================
--- c/src/exec/score/inline/address.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/inline/address.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -59,5 +59,5 @@
 )
 {
-  return (left - right);
+  return ((char *) left - (char *) right);
 }
 
Index: c/src/exec/score/inline/coremsg.inl
===================================================================
--- c/src/exec/score/inline/coremsg.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/inline/coremsg.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -18,4 +18,6 @@
 #define __CORE_MESSAGE_QUEUE_inl
 
+#include <string.h>   /* needed for memcpy */
+ 
 /*PAGE
  *
Index: c/src/exec/score/inline/rtems/score/address.inl
===================================================================
--- c/src/exec/score/inline/rtems/score/address.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/inline/rtems/score/address.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -59,5 +59,5 @@
 )
 {
-  return (left - right);
+  return ((char *) left - (char *) right);
 }
 
Index: c/src/exec/score/inline/rtems/score/coremsg.inl
===================================================================
--- c/src/exec/score/inline/rtems/score/coremsg.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/inline/rtems/score/coremsg.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -18,4 +18,6 @@
 #define __CORE_MESSAGE_QUEUE_inl
 
+#include <string.h>   /* needed for memcpy */
+ 
 /*PAGE
  *
Index: c/src/exec/score/inline/rtems/score/thread.inl
===================================================================
--- c/src/exec/score/inline/rtems/score/thread.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/inline/rtems/score/thread.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -242,9 +242,11 @@
   Objects_Classes      the_class;
   Objects_Information *information;
+  Thread_Control      *tp = (Thread_Control *) 0;
  
   if ( _Objects_Are_ids_equal( id, OBJECTS_ID_OF_SELF ) ) {
     _Thread_Disable_dispatch();
     *location = OBJECTS_LOCAL;
-    return( _Thread_Executing );
+    tp = _Thread_Executing;
+    goto done;
   }
  
@@ -253,5 +255,5 @@
   if ( the_class > OBJECTS_CLASSES_LAST ) {
     *location = OBJECTS_ERROR;
-    return (Thread_Control *) 0;
+    goto done;
   }
  
@@ -260,9 +262,13 @@
   if ( !information || !information->is_thread ) {
     *location = OBJECTS_ERROR;
-    return (Thread_Control *) 0;
+    goto done;
   }
  
-  return (Thread_Control *) _Objects_Get( information, id, location );
-}
+  tp = (Thread_Control *) _Objects_Get( information, id, location );
+ 
+done:
+  return tp;
+}
+
 
 /*
Index: c/src/exec/score/inline/thread.inl
===================================================================
--- c/src/exec/score/inline/thread.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/inline/thread.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -242,9 +242,11 @@
   Objects_Classes      the_class;
   Objects_Information *information;
+  Thread_Control      *tp = (Thread_Control *) 0;
  
   if ( _Objects_Are_ids_equal( id, OBJECTS_ID_OF_SELF ) ) {
     _Thread_Disable_dispatch();
     *location = OBJECTS_LOCAL;
-    return( _Thread_Executing );
+    tp = _Thread_Executing;
+    goto done;
   }
  
@@ -253,5 +255,5 @@
   if ( the_class > OBJECTS_CLASSES_LAST ) {
     *location = OBJECTS_ERROR;
-    return (Thread_Control *) 0;
+    goto done;
   }
  
@@ -260,9 +262,13 @@
   if ( !information || !information->is_thread ) {
     *location = OBJECTS_ERROR;
-    return (Thread_Control *) 0;
+    goto done;
   }
  
-  return (Thread_Control *) _Objects_Get( information, id, location );
-}
+  tp = (Thread_Control *) _Objects_Get( information, id, location );
+ 
+done:
+  return tp;
+}
+
 
 /*
Index: c/src/lib/include/rtems/assoc.h
===================================================================
--- c/src/lib/include/rtems/assoc.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/include/rtems/assoc.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,4 @@
 /*
- *	@(#)assoc.h	1.2 - 95/06/28
+ *	@(#)assoc.h	1.4 - 95/10/25
  *	
  *
@@ -14,5 +14,5 @@
 
 typedef struct {
-    char *name;
+    const char   *name;
     unsigned32   local_value;
     unsigned32   remote_value;
@@ -25,19 +25,19 @@
 #define RTEMS_ASSOC_DEFAULT_NAME "(default)"
 
-rtems_assoc_t *rtems_assoc_ptr_by_name(rtems_assoc_t *, char *);
-rtems_assoc_t *rtems_assoc_ptr_by_value(rtems_assoc_t *, unsigned32);
-rtems_assoc_t *rtems_assoc_ptr_by_remote(rtems_assoc_t *, unsigned32);
+const rtems_assoc_t *rtems_assoc_ptr_by_name(const rtems_assoc_t *, const char *);
+const rtems_assoc_t *rtems_assoc_ptr_by_value(const rtems_assoc_t *, unsigned32);
+const rtems_assoc_t *rtems_assoc_ptr_by_remote(const rtems_assoc_t *, unsigned32);
 
-unsigned32   rtems_assoc_remote_by_local(rtems_assoc_t *, unsigned32);
-unsigned32   rtems_assoc_local_by_remote(rtems_assoc_t *, unsigned32);
-unsigned32   rtems_assoc_remote_by_name(rtems_assoc_t *, char *);
-unsigned32   rtems_assoc_local_by_name(rtems_assoc_t *, char *);
-char        *rtems_assoc_name_by_local(rtems_assoc_t *, unsigned32);
-char        *rtems_assoc_name_by_remote(rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_remote_by_local(const rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_local_by_remote(const rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_remote_by_name(const rtems_assoc_t *, const char *);
+unsigned32   rtems_assoc_local_by_name(const rtems_assoc_t *, const char *);
+const char  *rtems_assoc_name_by_local(const rtems_assoc_t *, unsigned32);
+const char  *rtems_assoc_name_by_remote(const rtems_assoc_t *, unsigned32);
 
-unsigned32   rtems_assoc_remote_by_local_bitfield(rtems_assoc_t *, unsigned32);
-char        *rtems_assoc_name_by_local_bitfield(rtems_assoc_t *, unsigned32, char *);
-char        *rtems_assoc_name_by_remote_bitfield(rtems_assoc_t *, unsigned32, char *);
-unsigned32   rtems_assoc_local_by_remote_bitfield(rtems_assoc_t *ap, unsigned32);
+unsigned32   rtems_assoc_remote_by_local_bitfield(const rtems_assoc_t *, unsigned32);
+char  *rtems_assoc_name_by_local_bitfield(const rtems_assoc_t *, unsigned32, char *);
+char  *rtems_assoc_name_by_remote_bitfield(const rtems_assoc_t *, unsigned32, char *);
+unsigned32   rtems_assoc_local_by_remote_bitfield(const rtems_assoc_t *, unsigned32);
 
 
Index: c/src/lib/include/rtems/error.h
===================================================================
--- c/src/lib/include/rtems/error.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/include/rtems/error.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,5 @@
+
 /*
- *	@(#)error.h	1.1 - 95/08/02
+ *	@(#)error.h	1.3 - 95/10/25
  *	
  *
@@ -7,4 +8,7 @@
  *  $Id$
  */
+
+#ifndef __RTEMS_ERROR_h
+#define __RTEMS_ERROR_h
 
 /*
@@ -19,8 +23,10 @@
                              RTEMS_ERROR_PANIC) /* all */
 
-char *rtems_status_text(rtems_status_code);
-int   rtems_error(int error_code, char *printf_format, ...);
-void  rtems_panic(char *printf_format, ...);
+const char *rtems_status_text(rtems_status_code);
+int   rtems_error(int error_code, const char *printf_format, ...);
+void  rtems_panic(const char *printf_format, ...);
 
 extern int rtems_panic_in_progress;
 
+#endif
+/* end of include file */
Index: c/src/lib/include/rtems/libcsupport.h
===================================================================
--- c/src/lib/include/rtems/libcsupport.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/include/rtems/libcsupport.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -30,5 +30,8 @@
 );
 
+extern void malloc_dump(void);
 extern void libc_init(int reentrant);
+extern int  host_errno(void);
+extern void fix_syscall_errno(void);
 
 #ifdef __cplusplus
@@ -36,7 +39,4 @@
 #endif
 
-extern int  host_errno(void);
-extern void fix_syscall_errno(void);
-
 #endif
 /* end of include file */
Index: c/src/lib/libbsp/hppa1.1/simhppa/include/bsp.h
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/include/bsp.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/hppa1.1/simhppa/include/bsp.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -67,9 +67,34 @@
 
 /*
+ * Todo: this should be put somewhere else
+ */
+
+#undef CLOCK_DRIVER_TABLE_ENTRY
+#define CLOCK_DRIVER_TABLE_ENTRY { Clock_initialize, NULL, NULL, NULL, NULL, Clock_control }
+rtems_device_driver Clock_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+);
+
+/*
  * We printf() to a buffer if multiprocessing, *or* if this is set.
- * ref: src/lib/libbsp/hppa/simhppa/iosupp/consupp.c
+ * ref: src/lib/libbsp/hppa/pxfl/iosupp/consupp.c
  */
 
 extern int use_print_buffer;
+
+/*
+ * When not doing printf to a buffer, we do printf thru RTEMS libio
+ * and our tty driver.  Set it up so that console is right.
+ */
+
+#define CONSOLE_DRIVER_TABLE_ENTRY \
+  { tty_initialize, tty_open, tty_close, tty_read, tty_write, tty_control }
+
+/*
+ * How many libio files we want
+ */
+#define BSP_LIBIO_MAX_FDS       20
 
 /*
@@ -98,4 +123,6 @@
 rtems_isr_entry set_vector(rtems_isr_entry, rtems_vector_number, int);
 
+rtems_isr_entry set_vector(rtems_isr_entry, rtems_vector_number, int);
+
 void bsp_start( void );
 void bsp_cleanup( void );
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/getcfg.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/getcfg.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/getcfg.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -36,5 +36,4 @@
 
 #include <bsp.h>
-#include <runway.h>
 
 #include <shm.h>
@@ -44,14 +43,14 @@
 
 #define HPPA_RUNWAY_PROC_HPA_BASE  ((void *) 0xFFFA0000)
- 
+
 /* given a processor number, where is its HPA? */
 #define HPPA_RUNWAY_HPA(cpu)   \
   ((rtems_unsigned32) (HPPA_RUNWAY_PROC_HPA_BASE + ((cpu) * 0x2000)))
- 
+
 #define HPPA_RUNWAY_REG_IO_EIR_OFFSET   0x000
 
 shm_config_table BSP_shm_cfgtbl;
 
-void Shm_Cause_interrupt_pxfl( rtems_unsigned32 node );
+extern void Shm_Cause_interrupt_pxfl( rtems_unsigned32 node );
 
 void Shm_Get_configuration(
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/intr.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/intr.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/intr.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -23,4 +23,6 @@
 
 #include <rtems.h>
+#include <rtems/error.h>
+
 #include <shm.h>
 
@@ -39,4 +41,5 @@
     case NO_INTERRUPT:
        break;
+
     case LONG:
       u32   = (rtems_unsigned32 *)intr->address;
@@ -45,6 +48,4 @@
     default:
       fprintf( stderr, "Shm_Cause_interrupt_pxfl: Unsupported length!!!\n" );
-      rtems_shutdown_executive( 0 );
-      break;
   }
 }
Index: c/src/lib/libbsp/shmdr/getlq.c
===================================================================
--- c/src/lib/libbsp/shmdr/getlq.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/shmdr/getlq.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -23,5 +23,5 @@
 
 #include <rtems.h>
-#include "shm.h"
+#include <shm.h>
 
 Shm_Envelope_control *Shm_Locked_queue_Get(
Index: c/src/lib/libbsp/shmdr/shm.h
===================================================================
--- c/src/lib/libbsp/shmdr/shm.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/shmdr/shm.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -471,9 +471,5 @@
 void           Init_env_pool();
 void           Shm_Print_statistics( void );
-void           MPCI_Fatal(
-  Internal_errors_Source  source,
-  boolean                 is_internal,
-  rtems_unsigned32        error
- );
+void           MPCI_Fatal( Internal_errors_Source, boolean, rtems_unsigned32 );
 rtems_task     Shm_Cause_interrupt( rtems_unsigned32 );
 void           Shm_Poll();
Index: c/src/lib/libbsp/shmdr/shm_driver.h
===================================================================
--- c/src/lib/libbsp/shmdr/shm_driver.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/shmdr/shm_driver.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -471,9 +471,5 @@
 void           Init_env_pool();
 void           Shm_Print_statistics( void );
-void           MPCI_Fatal(
-  Internal_errors_Source  source,
-  boolean                 is_internal,
-  rtems_unsigned32        error
- );
+void           MPCI_Fatal( Internal_errors_Source, boolean, rtems_unsigned32 );
 rtems_task     Shm_Cause_interrupt( rtems_unsigned32 );
 void           Shm_Poll();
Index: c/src/lib/libbsp/unix/posix/shmsupp/getcfg.c
===================================================================
--- c/src/lib/libbsp/unix/posix/shmsupp/getcfg.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/unix/posix/shmsupp/getcfg.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -28,8 +28,9 @@
 #include <bsp.h>
 #include <shm.h>
+#include <sys/types.h>    /* pid_t */
 
 shm_config_table BSP_shm_cfgtbl;
 
-int              semid;
+int semid;
 
 void Shm_Cause_interrupt_unix(
Index: c/src/lib/libbsp/unix/posix/shmsupp/intr.c
===================================================================
--- c/src/lib/libbsp/unix/posix/shmsupp/intr.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/unix/posix/shmsupp/intr.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -22,4 +22,5 @@
 #include <bsp.h>
 #include <shm.h>
+#include <sys/types.h>      /* pid_t */
 
 void Shm_Cause_interrupt_unix(
@@ -30,4 +31,4 @@
   intr = &Shm_Interrupt_table[node];
  
-  _CPU_SHM_Send_interrupt( (int) intr->address, (int) intr->value );
+  _CPU_SHM_Send_interrupt( (pid_t) intr->address, intr->value );
 }
Index: c/src/lib/libbsp/unix/posix/shmsupp/lock.c
===================================================================
--- c/src/lib/libbsp/unix/posix/shmsupp/lock.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/unix/posix/shmsupp/lock.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -20,6 +20,4 @@
 #include <bsp.h>
 #include <shm.h>
-
-extern int      semid;
 
 /*
Index: c/src/lib/libbsp/unix/posix/startup/no-ctor.c
===================================================================
--- c/src/lib/libbsp/unix/posix/startup/no-ctor.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
+++ c/src/lib/libbsp/unix/posix/startup/no-ctor.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -0,0 +1,16 @@
+/*
+ *  rtems, floss, libc are always compiled with GNU compilers
+ *  application code may be compiled with some other C++ compiler
+ *  that has a different global constructor technique.
+ *
+ *  For the simple case, where the app has no global constructors or
+ *  is compiled by g++, we provide this empty routine
+ *  In order to get both g++ constructors (RTEMS::RTEMS, for example)
+ *  and application constructors run, we provide this routine.
+ *
+ *  $Id$
+ */
+
+void invoke_non_gnu_constructors(void)
+{
+}
Index: c/src/lib/libbsp/unix/posix/startup/rtems-ctor.cc
===================================================================
--- c/src/lib/libbsp/unix/posix/startup/rtems-ctor.cc	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/lib/libbsp/unix/posix/startup/rtems-ctor.cc	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,4 @@
+// 
 // 	@(#)rtems-ctor.cc	1.6 - 95/04/25
-// 
 //
 
@@ -82,4 +82,6 @@
 
 extern "C" {
+    extern void invoke_non_gnu_constructors(void);
+
     int
     main(int argc,
@@ -95,4 +97,10 @@
         else
             rtems_progname = "RTEMS";
+
+        /*
+         * run any non-gnu constructors we may need
+         */
+        
+        invoke_non_gnu_constructors();
 
         /*
